// CoilWrDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CoilWr.h"
#include "CoilWrDlg.h"

#include "..\..\include\AdamRtuCE.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCoilWrDlg dialog

CCoilWrDlg::CCoilWrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCoilWrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCoilWrDlg)
	m_strDeviceID = _T("");
	m_strDLLVersion = _T("");
	m_strNoOfWrite = _T("");
	m_strStartAddress = _T("");
	m_nStart0 = -1;
	m_nStart1 = -1;
	m_nStart2 = -1;
	m_nStart3 = -1;
	m_nStart4 = -1;
	m_nStart5 = -1;
	m_nStart6 = -1;
	m_nStart7 = -1;
	m_strCOMPort = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCoilWrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCoilWrDlg)
	DDX_Text(pDX, IDC_EDIT_DEVICEID, m_strDeviceID);
	DDX_Text(pDX, IDC_EDIT_DLLVER, m_strDLLVersion);
	DDX_Text(pDX, IDC_EDIT_NOOFWRITE, m_strNoOfWrite);
	DDX_Text(pDX, IDC_EDIT_STARTADDRESS, m_strStartAddress);
	DDX_Radio(pDX, IDC_RADIO1, m_nStart0);
	DDX_Radio(pDX, IDC_RADIO3, m_nStart1);
	DDX_Radio(pDX, IDC_RADIO5, m_nStart2);
	DDX_Radio(pDX, IDC_RADIO7, m_nStart3);
	DDX_Radio(pDX, IDC_RADIO9, m_nStart4);
	DDX_Radio(pDX, IDC_RADIO11, m_nStart5);
	DDX_Radio(pDX, IDC_RADIO13, m_nStart6);
	DDX_Radio(pDX, IDC_RADIO15, m_nStart7);
	DDX_CBString(pDX, IDC_COMPORT, m_strCOMPort);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCoilWrDlg, CDialog)
	//{{AFX_MSG_MAP(CCoilWrDlg)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_WRITECOIL, OnWritecoil)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCoilWrDlg message handlers

BOOL CCoilWrDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_strCOMPort="1";
	m_strDeviceID="1";
	m_strStartAddress="1";
	m_strNoOfWrite="8";

	SetDlgItemText(IDC_COMPORT,m_strCOMPort);
	SetDlgItemText(IDC_EDIT_DEVICEID,m_strDeviceID);
	SetDlgItemText(IDC_EDIT_STARTADDRESS,m_strStartAddress);
	SetDlgItemText(IDC_EDIT_NOOFWRITE,m_strNoOfWrite);

	CButton*  pRadioButton;
	int       nID,i;

    nID=IDC_RADIO1;
	for(i=0; i<8; i++)
	{

	    pRadioButton=(CButton *)GetDlgItem(nID+2*i);
		pRadioButton->SetCheck(BST_CHECKED);
	}

	// get the DLL version 
	char     szCh[20];
    int     iVersion;    
 
	iVersion=ADAMRTU_GetDLLVersion();
	_ltoa( iVersion, szCh, 16 );

	size_t len = strlen (szCh);
	wchar_t  wcConverter[20];

	memset (wcConverter, 0, sizeof(wcConverter));
	mbstowcs(wcConverter, szCh, len);
	SetDlgItemText(IDC_EDIT_DLLVER, wcConverter);  
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CCoilWrDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
    CDialog::OnOK();	
}

void CCoilWrDlg::OnWritecoil() 
{
	// TODO: Add your control notification handler code here
    CString   strText,strTemp;
	int       i,nID,iRetVal;
	WORD      wDeviceID;
    WORD      wStartAddress;
    WORD      wCount;
	WORD      wData[16];
	int       CoilValue[16];
	CButton*  pRadioButton;
	TCHAR	  szwTemp[80];
	int       iComPort,iBaudRate,iTimeout;
    long      lPortHandle;

    // iComPort=2;
    iBaudRate=9600;
	iTimeout=1000;   // timeout interval: 1000 mSec

	// which COM Port to use
	GetDlgItemText(IDC_COMPORT, szwTemp, 80*sizeof(TCHAR));
	iComPort = (unsigned short)_wtoi(szwTemp);

    lPortHandle = ADAMRTU_Open(iComPort);
    if (lPortHandle == (long)INVALID_HANDLE_VALUE)
    {
        MessageBox(_T("ADAM_Open() Failure !!!"));
        return;            
    }      

    iRetVal=ADAMRTU_SetCommState(lPortHandle, iBaudRate, 
                                 ADAMRTU_PARITY_NO, DATEBITS_8, STOPBIT_1);
	if( iRetVal!=0 )
	{
        MessageBox(_T("ADAM_SetCoommState() Failure !!!"));
        ADAMRTU_Close(lPortHandle);		
		return;
	}

    nID=IDC_RADIO1;
	for(i=0; i<8; i++)
	{

	    pRadioButton=(CButton *)GetDlgItem(nID+2*i);
		if( pRadioButton->GetCheck()==BST_CHECKED )
			CoilValue[i]=0;
		else
			CoilValue[i]=1;
	}

	// How many coils to write
	GetDlgItemText(IDC_EDIT_NOOFWRITE, szwTemp, 80*sizeof(TCHAR));
	wCount = (unsigned short)_wtoi(szwTemp);
	if( wCount<0 || wCount>8 )
	{
		MessageBox( _T("The # of Coil must between 1 to 8 !") );
		return;
	}

	// the Device ID
	GetDlgItemText(IDC_EDIT_DEVICEID,szwTemp, 80*sizeof(TCHAR));
	wDeviceID = (unsigned short)_wtoi(szwTemp);

	// the start address to write
	GetDlgItemText(IDC_EDIT_STARTADDRESS,szwTemp, 80*sizeof(TCHAR));
	wStartAddress = (unsigned short)_wtoi(szwTemp);

    //--- prepare data to write to coil ---
	for(i=0; i<wCount; i++)
		wData[i]=CoilValue[i];

    iRetVal=ADAMRTU_WriteCoil(lPortHandle, wDeviceID, wStartAddress, wCount, wData, iTimeout);
    if( iRetVal )
    {
		ADAMRTU_Close(lPortHandle);
		MessageBox( _T("ADAMRTU_WriteCoil() Failure !!!") );
        return;
    }
    
	iRetVal=ADAMRTU_Close(lPortHandle);
    if( iRetVal )
    {
	   MessageBox( _T("Failure to ADAMRTU_Close()") );
	   return;
    }

}
